'''

FluxNoiseAnalysis/ds.py

Dataset loading with caching.

'''

from pyle.plotting import dstools
from pyle.registry import AttrDict
## util
ds_class = AttrDict
ds_cache = {}
def getDataset(dv, num, path):
    k = '%s - %s' % (num, path)
    if k not in ds_cache:
        ds_cache[k] = dstools.getDeviceDataset(dv, num, path)
    return ds_cache[k]
def invalidateCache():
    global ds_cache
    ds_cache = {}

def getParam(d, param, q=None):
    ''' get a parameter from a dataset. '''
    # TODO handle multi-qubit datasets
    if q is None:
        q = getQubit(d)
    else:
        q = d['parameters'][q]
    return q[param]
    
def getName(d):
    ''' Get the name of a dataset '''
    return d['parameters']['stack.frame0.arg']['name'].replace("'", "")
        
def getQubit(d, measure=0):
    ''' get a param dict for a qubit from a dataset. '''
    q = d['parameters']['config'][d['parameters']['measure'][measure]]
    return d['parameters'][q]
