'''

FluxNoiseAnalysis/units.py

Common units for RTO data.

'''

import labrad.units
from labrad.units import Unit
from numpy import pi

sec, ns, GHz, Hz, MHz, V = (Unit(s) for s in ['s','ns','GHz','Hz','MHz', 'V'])
# define Phi_0 and micro-Phi_0
Phi0_v = labrad.units.hbar*pi/labrad.units.e
Phi0_u = Unit('Phi', 1, Phi0_v)
uPhi0_u = Unit('uPhi', 10**-6, Phi0_u)
# A DAC Amplitude of 1 corresponds to 200 mV
DacAmp_u = Unit('DacAmp', 0.2, 'V')
