from pyle.test import testQubits as tq
from pyle import gateCompiler as gc

class repCodeTest(tq.testBase):
    def setUp(self):
        sample, devs, qubits = gc.loadQubits(self.Sample, self.measure, write_access=False)
        self.devs = devs
        self.qubits = qubits
        qubitDict = {}
        for qubit in qubits:
            qubitDict[qubit.__name__] = qubit
        self.qubitDict = qubitDict
        
    def test_rep_code_block_lens(self, qubitName):
        qubit = self.qubitDict[qubitName]
        piLen = qubit['piLen']
        aczKeys = [x for x in qubit.keys() if 'aczAmp' in x]
        for key in aczKeys:
            tName = key.strip('aczAmp')
            targetQubit = self.qubitDict[tName]
            totalAczLen = qubit[tName+'aczTime'] + qubit['aczPadding'] + targetQubit['aczDetunePadding']
            try: assert( piLen*2 == totalAczLen ),"REP BLOCK LEN: %s has piLen: %s, Acz total len: %s" % (qubit.__name__, piLen, totalAczLen)
            except Exception as e: print e