import os, sys
sys.path.insert(1, 'U:\Peter\pyle\dev\pyle')

import matplotlib
#matplotlib.use('Qt4Agg')
import numpy as np, matplotlib.pyplot as plt

import labrad
from labrad.units import Unit,Value

from pyle.util import registry_wrapper2 as registry
from pyle import envelopes as env
from pyle.dataking import envelopehelpers as eh
from pyle.util import sweeptools as st
from pyle.workflow import switchSession as pss
from pyle.plotting import dstools as ds
from pyle.plotting import plothelper as ph
from pyle.sim import pyleSim as ps
from pyle.sim import pyleSimQ as psq
from pyle.sim import pyleSimQR as psqr
from pyle.sim import pyleSimQRQ as psqrq
from pyle import gateCompiler as gc
from pyle import gates
from pyle.dataking import fpgaseqTransmon as ft
from pyle.dataking import singleQubit as sq
from pyle.dataking import multipleQubit as mq
from pyle.dataking.DevDaniel.Qubit import readoutScans as rs
from pyle.dataking import automateDaily as ad
from pyle.datavault import DataVaultWrapper
from pyle.dataking import util as util
from pyle.dataking.benchmarking import randomizedBenchmarking as rb
from pyle.fitting import fitting as fitting

import pyle.analysis.FluxNoiseAnalysis as fna
import pyle.dataking.dephasingSweeps as dphs

import pyle.dataking.DevJulian.nueve as nueve

plt.ion()
matplotlib.rcParams['axes.grid'] = True
matplotlib.rcParams['lines.marker'] = '.'
matplotlib.rcParams['lines.linestyle'] = None
matplotlib.rcParams['font.size'] = 19

rad, ns, us, sec, MHz, GHz, mV, V, dBm = (Unit(s) for s in ['rad','ns','us','s','MHz','GHz','mV','V','dBm'])

def switchSession(session=None, user=None):
    """Switch the current session, using the global connection object"""
    global s, cxn
    if user is None:
        user = s._dir[1]
    from pyle.workflow import switchSession as pss
    s = pss(cxn, user, session)
    global dvw
    dvw = DataVaultWrapper(s)


# connect to labrad and setup a wrapper for the current sample
cxn = labrad.connect()
switchSession(user='Peter')


