# Rami Barends 2013
#
# RB test routines

import numpy as np
import time
from pyle.dataking import util
from pyle import gateCompiler as gc
from pyle.dataking.benchmarking import randomizedBenchmarking as rb
from pyle import gates
import matplotlib.pyplot as plt
from pyle.math import tensor, dagger, dot3
from pyle.sim import pyleSim as ps
envplot=False #plot envelopes

def testSQ(Sample,measure='q1',m=3,interleaved=False,plot=True,printall=True,IW=None):
    sample, devs, qubit, Qubit = gc.loadQubits(Sample, measure, write_access=True)
    #sample, qubits = util.loadQubits(s)
    print qubit['alphaDRAG']
    #q1 = qubits[measure]
    #q1['readout']=True
    #devs = gc.registryWrapper2GateCompiler(sample, qubits)
    #q1=devs[measure]
    #q = gc.AttrDict2Qubit(q, gc.Transmon)
    if IW:
        qubit['identityWaitLen']=IW
    RBClass=rb.RandomizedBenchMarkingClifford(1)
    RBClass.setGateLengths([qubit])    
    
    tic=time.time()    
    #seq=RBClass.randGen([m],interleaved=interleaved)
    #seqf=RBClass.finishGateList(seq)
    seqf=RBClass.randGen([m],interleaved=interleaved,finish=True)  
    toc=time.time()
    print 'time for rb: ', toc-tic    
    
    seqLength= RBClass.computeGateLength(seqf)
    print seqLength[-1]
    print RBClass.computeAvgCliffordLength()    
    
    if printall:
        for ss in seqf:
            print ss[0]
            print ' '
        
    U=RBClass.computeUnitary(seqf)
    fidelity = abs(np.trace(U))**2/(1.*2**(2*1))
    print fidelity        
        
    tic=time.time()         
    alg = gc.Algorithm(agents=devs)
    alg[gates.RandomizedBenchmarkingSingleQubitClifford([alg.q0],seqf)]
    #alg[gates.RandomizedBenchmarkingMultiQubitClifford([q1,q2],seqf)]
    alg.compile()
    toc=time.time()
    print 'time for alg: ', toc-tic    
    print devs
    if plot:
        #ps.plotPulses([alg.q0])
    #'''
        t=np.linspace(0,seqLength[-1],16001)
        y=alg.q0['xy'](t)
        if envplot:
            y=abs(y)
        y2=alg.q0['z'](t)    
        plt.figure()
        plt.plot(t,y,'b',t,y2,'r')
        plt.show()
    #'''
def countMQ(s,m=1,interleaved=False,measure=[2,3],plot=True,tel=10):
    '''Counts how many cz's there are'''
    sample, qubits = util.loadQubits(s)
    q1 = qubits[ measure[0] ]
    q2 = qubits[ measure[1] ]
    q1['readout']=True
    q2['readout']=True
    devs = gc.registryWrapper2GateCompiler(sample, qubits)
    q1=devs[ measure[0] ]
    q2=devs[ measure[1] ]
    #q = gc.AttrDict2Qubit(q, gc.Transmon)

    RBClass=rb.RandomizedBenchMarkingClifford(2)
    RBClass.setGateLengths([q1,q2])
    tic=time.time()
    
    seqLength=[]
    numberofCZs=[]
    for t in range(tel):
        seq=RBClass.randGen([m],interleaved=interleaved)
        seqf=RBClass.finishGateList(seq)
        seqLength.append( RBClass.computeGateLength(seqf)[-1] )
        numberofCZsinseq=0
        for ss in seqf:
            print ss[0]
            print ss[1]
            print ' '         
            numberofCZsinseq += ss[0].count('CZ')
        numberofCZs.append( numberofCZsinseq )

    seqLength = np.mean( np.array( seqLength) )
    numberofCZs = np.mean( np.array( numberofCZs) )    
    print seqLength, numberofCZs

    
    
def testMQ(Sample,m=3,interleaved=False,measure=['q3','q2'],plot=True,printall=True):
    sample, devs, qubits, Qubits = gc.loadQubits(Sample, measure, write_access=True)

    RBClass=rb.RandomizedBenchMarkingClifford(2)
    RBClass.setGateLengths([qubits[0],qubits[1]])
    tic=time.time()
    
    print RBClass.gateLengths
    #seq=RBClass.randGen([m],interleaved=interleaved)
    #seqf=RBClass.finishGateList(seq)
    seqf=RBClass.randGen([m],interleaved=interleaved,finish=True)
    seqLength= RBClass.computeGateLength(seqf)
    toc=time.time()
 
    #hu2u6
    #print RBClass.computeAvgCliffordLength()
    if printall:
        for ss in seqf:
            print ss[0]
            print ss[1]
            print ' '    
       
    print 'time for rb: ', toc-tic
    print seqLength[-1]          
       
    U=RBClass.computeUnitary(seqf)
    fidelity = abs(np.trace(U))**2/(1.*2**(2*2))
    print 'fidelity: ',fidelity
    
    tic=time.time()
    alg = gc.Algorithm(agents=devs)
    #q1['q3aczAmp']=0.0
    #alg[gates.RandomizedBenchmarkingSingleQubitClifford([q1],seqf)]
    alg[gates.RandomizedBenchmarkingMultiQubitClifford([alg.q0,alg.q1],seqf)]
    alg.compile()
    toc=time.time()
    print 'time for alg: ', toc-tic
    
    if plot:
        t=np.linspace(0,seqLength[-1],16001)
        y=alg.q0['xy'](t)
        y2=alg.q1['xy'](t)
        if envplot:
            y=abs(y)
            y2=abs(y2)
        y3=alg.q0['z'](t)
        plt.figure()
        lines=plt.plot(t,y,'b',t,y2,'g',t,y3,'r')
        plt.setp(lines, linewidth=2.0)
        plt.show()