import sys
sys.path.append('N:\\dev\\pyle\\')
import labrad
from labrad.units import Unit
from labrad.types import Value
from pyle.util import sweeptools as st
from pyle.plotting import dstools as ds
V, GHz, MHz, Hz, dBm, dB, K, rad= [Unit(s) for s in 
                              ('V','GHz','MHz', 'Hz', 'dBm', 'dB', 'K', 'rad')]
import numpy as np
import time
from time import sleep
import davidutil as util


def get_temp(cxn):
    return float(.050)

def get_pna_data(pna, start_freq, stop_freq):
    print "Die"
    return 0
        # pna.frequency_range(start_freq, stop_freq)
        # while True:
            # try:
                # raw_data = pna.freq_sweep()
            # except Exception, e:
                # continue
            # break	
        # f = raw_data[0].asarray
        # s = raw_data[1].asarray.T
        # f.shape = (len(f), 1)
        # pna_data = np.hstack((f, s))
        # return pna_data

# def getMagPhase(c): #returns magnitude and phase of pna data
        # return 2 * 10 * np.log10(abs(c)), np.angle(c)

# def switchPNA(cxn,pna):
    # if(pna == '5230A'):
        # return cxn.agilent_n5230a_pna 
    # elif (pna == '5242A'):
        # return cxn.pna_x ## ('Kimble GPIB Bus - TCPIP0::A-N5242A-21947::inst0') 
    # print "No valid pna selected"
    # return 0
    
def pna_scan(sample, name = '', freqsweep = st.r[8.3:8.6:0.1, GHz],
             num_points = 800, averages = 1, power = -20*dBm, 
             bandwidth = 100 * Hz, pnaAverages = 1,
             pnaname = '5230A',
             scandir = ['ResXX','power']):
    
    """Do a PNA Scan for a range of frequencies. The PNA is limited to 16000 
       points per sweep, so we can break long scans into chunks of high 
       resolution. The variable freqsweep tells the PNA how to break up a long 
       scan into chunks.
       
       For example: if we were to do freqsweep = st.r[8.0:9.0:0.5, GHz] that 
       tells the PNA to sweep from 8.0 to 9.0 GHz in chunks of 500MHz.  This 
       means that num_points will be the number of points per chunk, with a 
       maximum of 16000.
    
       If averages > 1, a subdirectory will be created where all of the raw 
       data is stored. Once all of the raw data has come in, an averaged 
       version of the data will be created and saved in the current directory. 
    """
    
    cxn = sample._cxn
        
    if sample['port'] == 'Port1':
        independents = ['frequency [GHz]']
        dependents = ['Magnitude (S21) [dB]', 'Phase (S21) [rad]',
                      'Magnitude (S11) [dB]', 'Phase (S11) [rad]']
    elif sample['port'] == 'Port2':
        independents = ['frequency [GHz]']
        dependents = ['Magnitude (S22) [dB]', 'Phase (S22) [rad]',
                                                   'Magnitude (S12) [dB]', 'Phase (S12) [rad]']
    
    # get the parameters from the data vault
    parameters = {}
    parameters.update(sample)
    parameters['bandwidth'] = bandwidth
    parameters['freq_start'] = freqsweep[0]
    parameters['freq_stop'] = freqsweep[-1]
    parameters['power'] = power
    parameters['num_points'] = num_points
    parameters['temp_start'] = get_temp(cxn)
    #pna = switchPNA(pnaname)
    #pna.select_device(sample['pna_gpib']) # in registry, GPIB 16
    #pna.power(power)
    #pna.bandwidth(bandwidth)
    #pna.num_points(int(num_points))
    [startTime, starTimeH] = util.getTimes()
    
    #if pnaAverages > 1:
    #    pna.averages(pnaAverages)

    #if sample['port'] == 'Port1':
    #    pna.s_parameters(['S11', 'S21'])
    #elif sample['port'] == 'Port2':
    #    pna.s_parameters(['S12', 'S22'])
        
    # set up data vault parameters
    dv = sample._cxn.data_vault
    dv.cd(sample._dir[:-1] + scandir, True)
    
    if averages > 1:
        nameString = ''.join([
                            'raw ', sample['_datasetname'], ' ', name,
                            str(util.getTimes()[1])
                            ])
        dv.mkdir(nameString)
        dv.cd(nameString)
    else:
        nameString = 'PNA Scan ' + sample['_datasetname'] + ' ' + name
        
    for dummy in range(averages): # save all of the raw data (if averaging)
        dv.new(nameString, independents, dependents)
        p = dv.packet()
        for parm in parameters:
            p.add_parameter(parm, parameters[parm])
        p.send()
        
        for k in range(len(freqsweep)-1):
            
            chunk_start_freq = freqsweep[k]
            chunk_stop_freq = freqsweep[k+1] - freqsweep.range.step/num_points 
            # this ugly subtraction value 
            # stops the data from being double valued at
            # the points where the data is stitched together.
            # it calculates the actual frequency step from the PNA
            
            #raw_data = get_pna_data(pna, chunk_start_freq, chunk_stop_freq)
            
            # add live view later
            #freqs = raw_data[:,0]*1e-9 # (downconvert to GHz)
            #S_through = getMagPhase(raw_data[:,1]) # S12 or S21, depending on PORT
            #S_reflected = getMagPhase(raw_data[:,2]) # S11 or S22 depending on PORT
            
            #data = np.array(np.vstack((freqs.T, S_reflected[0], S_reflected[1], S_through[0], S_through[1]))).T.astype(float)
            
            data = [k * 1.0*GHz, 
                    - k * 10.0 * dBm, k * 1.0*rad, 
                    - k * 20.0 * dBm, k * 2.0*rad
                   ]
            
            dv.add(data)
            try:
                timeF, timeFH = util.getTimes()
                dv.add_parameter('timeStart', startTime)
                dv.add_parameter('timeStart_human', startTimeH)
                dv.add_parameter('timeFinish', timeF)
                dv.add_parameter('timeFinish_human', timeFH)
            except Exception, e:
                continue
            
        
        print 'finished set number ' + str(dummy)
        
    if averages > 1:
    # get all of the averaged data    
        raw_data = [ds.getDataset(dv, m+1) for m in range(averages)] # +1 since the data vault starts at set #1
        
        for i in range(len(raw_data)):
            var = raw_data[i]
            var0 = [x[0] for x in var]	#Frequency
            var1 = [10**(x[1]/20) for x in var] #Magnitude
            var2 = [x[2] for x in var]	#Phase
            var3 = [x[3] for x in var]	#S11
            var4 = [x[4] for x in var] 	#S11
            reData = [var1[k]*np.cos(var2[k]) for k in range(len(var))]
            imData = [var1[k]*np.sin(var2[k]) for k in range(len(var))]
            for j in range(len(var)):
                raw_data[i][j] = [var0[j], reData[j], imData[j], var3[j], var4[j]]
            
        averaged_data = sum(raw_data)/averages
        
        for i in range(len(averaged_data)):
            var = averaged_data[i]
            mData = 20*np.log10((var[1]**2 + var[2]**2)**.5)
            pData = np.arctan2(var[2],var[1])
            averaged_data[i] = [var[0], mData, pData, var[3], var[4]]
        
        # set up data vault parameters
        dv = sample._cxn.data_vault
        dv.cd('')
        dv.cd(sample._dir[:-1] + scandir, True)
        nameString = 'PNA Scan(avg)' + sample['_datasetname'] + ' ' + name
        dv.new(nameString, independents, dependents)
        p = dv.packet()
        for parm in parameters:
            p.add_parameter(parm, parameters[parm])
        p.send()
        dv.add(averaged_data)
        
        currentTime = time.time()
                
        #dv.add_parameter('temp_stop', get_temp())
        dv.add_parameter('averages', averages)
        dv.add_parameter('time_elapsed_min', (currentTime - startTime)/60)
    
    #everything beyond here, for testing ONLY
    dv = sample._cxn.data_vault
    dv.cd('')
    dv.cd(sample._dir[:-1] + scandir, True)
    nameString = 'PNA Scan' + sample['_datasetname'] + ' ' + name
    dv.new(nameString, independents, dependents)
    p = dv.packet()
    for parm in parameters:
        p.add_parameter(parm, parameters[parm])
    p.send()
    
    def err (c):
        for i in range(len(c)):
            c[i] = 1/c[i]
            c[i] += ( np.random.randint(2) * (-1)**(np.random.randint(2)) * 
                        np.random.rand() * .5e-1 + 
                      np.random.randint(2) * (-1)**(np.random.randint(2)) * 
                        np.random.rand() * .5e-1 * 1j  
                    )
            c[i] = 1/c[i]
        return c
        
    import matplotlib.pyplot as plt
    
    def plotter(fdata, mdata, pdata, redata, imdata):
        fig = plt.figure()
        fig.subplots_adjust(wspace = 0.4)
        fig.subplots_adjust(hspace = 0.4)
        
        fig.add_subplot(221)
        plt.plot(fdata, mdata, 'b.')
        plt.xlabel('Frequency')
        plt.ylabel('Magnitude')

        fig.add_subplot(222)
        plt.plot(fdata,pdata, 'b.')
        plt.xlabel('Frequency')
        plt.ylabel('Phase in Radians')

        fig.add_subplot(223, aspect='equal' )
        plt.plot(np.real(cdata), np.imag(cdata), 'b.')
        plt.xlabel('real')
        plt.ylabel('imag')
        
        plt.show()
    
    funct = lambda f, v: 1 + (v[0]/v[2]) * np.exp(1j * v[3]) /     \
                                    (1 + 2j*v[0]*(f/v[1]-1) )
    fs    = np.linspace(parameters['freq_start'], 
                        parameters['freq_stop'], num_points)
    qi    = 4e6 #+ (-1)**(np.random.randint(2)) * np.random.rand() * 1e5
    mag   = lambda c: (np.real(c)**2.0 + np.imag(c)**2.0)**(0.5)
    magd  = lambda c: 20*np.log10(mag(c))
    phs   = lambda c: np.angle(c)
    qc    = 3e5
    phi   = 0
    
    cdata = err(funct(fs,[qi, 
                  .5 * (parameters['freq_stop'] + parameters['freq_start']) ,
                  qc, phi]))
    
    #print "Plot 1/S21 from PNAScan"
    #plotter(fs, magd(cdata), phs(cdata), np.real(cdata), np.imag(cdata))
    
    cdata = [cdata[i]**(-1) for i in range(len(cdata))]
    mdata = magd(cdata)
    
    pdata = phs(cdata)
    fdata = fs
    
    #print "Plot S21 from PNAScan"
    #plotter(fdata, mdata, pdata, np.real(cdata), np.imag(cdata))
    
    data = []
    
    for i in range(len(fdata)):
        data.append([fdata[i], mdata[i], pdata[i], mdata[i], pdata[i]])

    
    dv.add(data)