import labrad
import numpy as np
from matplotlib import pyplot as plt
from matplotlib.ticker import MaxNLocator
import plotParampData as ps


def compileInputWAmpData(cxn,dir,dataDir,start,chunk,cycles,
                         calGain, calNoise, vault = None, corr = 0, pumpCorr=0):
    ps.getCal(cxn)
    dataset, freq = ps.plotInputWData(cxn,dataDir,start,chunk,cycles,calGain = calGain,calNoise = calNoise, smooth = 10, plot = False, pumpCorr = pumpCorr)
    print freq
    if vault is None:
        dv = cxn.data_vault
    else:
        dv = vault
    dv.cd(dir)
    dv.new('Paramp Parameter Sweep %f GHz' % freq, ['Flux [mV]','Power [dBm]'],
           ['Bandwidth [MHz]','Gain [dB]','GBP [MHz]','Saturation Power [dBm]','Noise Temp [K]'])
    for item in dataset:
        data = dataset[item]
        try:
            point =  np.vstack((data[:,5], data[:,0], data[:,1:4].T, data[:,6:8].T)).T
            dv.add(point)
        except:
            point =  np.hstack((data[5], data[0], data[1:4], data[6:8]))
            dv.add(point)
    return dataset

def compile2WAmpData(cxn,dir,dataDir,start,cycles, calGain, calNoise, vault = None):
    ps.getCal(cxn)
    dataset, freq = ps.plot2WData(cxn,dataDir,start,cycles,calGain,calNoise, smooth = 10, plot = False)
    print freq
    if vault is None:
        dv = cxn.data_vault
    else:
        dv = vault
    dv.cd(dir)
    dv.new('Paramp Parameter Sweep %f GHz' % freq, ['Flux [mV]','Power [dBm]'],
           ['Bandwidth [MHz]','Gain [dB]','GBP [MHz]','Saturation Power [dBm]','Noise Temp [K]'])
    for item in dataset:
        data = dataset[item]
        try:
            point =  np.vstack((data[:,5], data[:,0], data[:,1:4].T, data[:,6:8].T)).T
            dv.add(point)
        except:
            point =  np.hstack((data[5], data[0], data[1:4], data[6:8]))
            dv.add(point)
    return dataset

def sortByFreq(sample, conn = None):
    if conn is None:
        cxn1 = sample._cxn
        cxn2 = sample._cxn
    else:
        cxn1 = conn
        cxn2 = sample._cxn
    dir = sample._dir
    dataDir = sample['dir']
    start =  sample['start']
    cycles = 0
    dv = cxn2.data_vault
    dv.cd(dataDir)
    sets = dv.dir()[1]
    print len(sets)
    compile = False
    for i in range(len(sets)):
        name = sets[i]
        number = int(sets[i].split('-')[0])
        if 'Phase vs Frequency and Power' in name and number > start:
            if compile:
                data = compile2WAmpData(cxn1, dir, dataDir, start, cycles, cg, cn, vault = dv)
                compile = False
            start = number+3
            cg = start-2
            cn = start-1
            cycles = 0
        if 'Frequency Sweep PNA' in name and number > start:
            if 'Frequency Sweep PNA' in sets[i+1]:
                data = compileAmpData(cxn,dir,dataDir,start,cycles,cg,cn)
                compile = False
                start = number+1
                cyclces = 0
                print 'break'
                print start
                print cg
                print cn
            else:
                cycles += 1
                compile = True
        
        