import labrad
from labrad.units import Unit
from labrad.types import Value
V, GHz, MHz, Hz, dBm, dB, K, ns = [Unit(s) for s in ('V','GHz','MHz', 'Hz', 'dBm', 'dB', 'K', 'ns')]
import numpy as np
import time
import setbias as sb
import powerScan as ps
import pyle.dataking.util as util
import frequencyScan as fs
import powerScan as ps
import noiseScan as ns
import time

def measure(sample):
    print 'loading parameters'
    cxn = sample._cxn
    # dc = cxn.dc_rack_server
    # dc.select_device(0)
    an = cxn.anritsu_server
    an.select_device()
    samp, dev = util.loadDeviceType(sample, 'PNA')
    PNA = sample['PNA']
    pump = np.arange(5.2,5.5,0.01)
    freq = pump
    pow = np.arange(-10.0,4.0,0.1)
    
    # pump = np.arange(6.5,8.5,1.0)
    
    # try:
    for pumps in pump:
        PNA['ParampPumpFreq']=pumps
        PNA['startFreq']=pumps-0.5
        PNA['stopFreq']=pumps+0.5
        an.frequency(pumps*GHz)
        an.output(False)
        calib = fs.freqScan(sample, save = False)
        freqlen = len(calib[:,0])
        an.output(True)
        # for fluxs in flux:
        first = True     
        for pows in pow:
            print freq, pows
            an.amplitude(pows)
            # dc.channel_set_voltage(3, 'A', 1, 0, fluxs)
            # PNA['ParampBiasVoltage']=fluxs
            PNA['ParampPumpPower']=pows
            PNA['name'] = 'vs power for %f GHz' %pumps
            powData = np.asarray([pows]*freqlen)
            powData.shape = (len(powData),1)
            data = fs.freqScan(sample, save = False)
            data[:,1] = data[:,1] - calib[:,1]
            freqs = data[:,0]
            freqs.shape = (len(freqs),1)
            data = np.hstack((freqs,powData,data[:,1:]))
            if first:
                dv = fs.saveData3D(sample,data)
                first = False
            else:
                fs.saveData3D(sample,data,dataVault = dv)
            # ps.powerScan(sample)
    an.output(False)
    # except:
        # print 'scan failed'
        # an.output(False)
        
        

def measureNoise(s):
    print 'loading parameters'
    cxn = sample._cxn
    dc = cxn.dc_rack_server
    dc.select_device(0)
    an = cxn.anritsu_server
    an.select_device()
    samp, dev = util.loadDeviceType(sample, 'noiseMeas')
    SA = sample['noiseMeas']
    flux = np.arange(-0.2,0.5,0.05)
    pow = np.arange(2.0,14.0,0.1)
    pump = np.arange(5.0,7.0,0.1)
    
    try:
        for pumps in pump:
            SA['ParampPumpFreq']=pumps*2
            SA['freq']=pumps*1000
            SA['span']=1000
            an.frequency(pumps*2.*GHz)
            an.output(False)
            calib = ns.takeNoiseScan(sample, save = False)
            freqlen = len(calib[:,0])
            an.output(True)
            for fluxs in flux:
                first = True
                for pows in pow:
                    print fluxs, pows
                    an.amplitude(pows)
                    dc.channel_set_voltage(3, 'A', 1, 0, fluxs)
                    SA['ParampBiasVoltage']=fluxs
                    SA['ParampPumpPower']=pows
                    SA['name'] = 'vs power for %f Vflux' %fluxs
                    powData = np.asarray([pows]*freqlen)
                    powData.shape = (len(powData),1)
                    try:
                        data = ns.takeNoiseScan(sample, save = False)
                        data[:,1] = data[:,1] - calib[:,1]
                        freqs = data[:,0]
                        freqs.shape = (len(freqs),1)
                        data = np.hstack((freqs,powData,data[:,1:]))
                        if first:
                            dv = ns.saveData3D(sample,data)
                            first = False
                        else:
                            ns.saveData3D(sample,data,dataVault = dv)
                    except:
                        time.sleep(1)
                        try:
                            data = ns.takeNoiseScan(sample, save = False)
                            data[:,1] = data[:,1] - calib[:,1]
                            freqs = data[:,0]
                            freqs.shape = (len(freqs),1)
                            data = np.hstack((freqs,powData,data[:,1:]))
                            if first:
                                dv = ns.saveData3D(sample,data)
                                first = False
                            else:
                                ns.saveData3D(sample,data,dataVault = dv)
                        except:
                            print 'Scan failed for power value of %f dBm' %pows
                    # ps.powerScan(sample)
        an.output(False)
    except:
        print 'scan failed'
        an.output(False)
        
def measureEverything(sample):
    print 'loading parameters'
    cxn = sample._cxn
    # dc = cxn.dc_rack_server
    # dc.select_device(0)
    an = cxn.anritsu_server
    an.select_device()
    samp, dev = util.loadDeviceType(sample, 'noiseMeas')
    SA = sample['noiseMeas']
    PNA = sample['PNA']
    # flux = np.arange(0,0.5,0.05)
    pow = np.arange(-10.0,-4.0,0.1)
    pump = np.arange(6.3,6.8,0.005)
    
    try:
        for pumps in pump:
            PNA['ParampPumpFreq']=pumps
            PNA['startFreq']=pumps-0.5
            PNA['stopFreq']=pumps+0.5
            an.frequency(pumps*GHz)
            an.output(False)
            calibg = fs.freqScan(sample, save = False)
            SA['ParampPumpFreq']=pumps
            SA['freq']=pumps*1000
            SA['span']=1000
            calibn = ns.takeNoiseScan(sample, save = False)
            freqlen = len(calibn[:,0])
            an.output(True)
            # for fluxs in flux:
            first = True
            for pows in pow:
                print pows
                an.amplitude(pows)
                # dc.channel_set_voltage(3, 'A', 1, 0, 0)
                # dc.channel_set_voltage(3, 'A', 1, 0, fluxs)
                # PNA['ParampBiasVoltage']=fluxs
                PNA['ParampPumpPower']=pows
                datasetName = 'Gain, noise gain, and SNR improvement vs power for %f GHz' %pumps
                print freqlen
                powData = np.asarray([pows]*freqlen)
                powData.shape = (len(powData),1)
                data = fs.freqScan(sample, save = False)
                data[:,1] = data[:,1] - calibg[:,1]
                freqs = data[:,0]
                print len(freqs)
                freqs.shape = (len(freqs),1)
                print len(freqs)
                data = np.hstack((freqs,powData,data[:,1:2]))
                an.amplitude(pows)
                # dc.channel_set_voltage(3, 'A', 1, 0, fluxs)
                # SA['ParampBiasVoltage']=fluxs
                SA['ParampPumpPower']=pows
                SA['name'] = 'vs power for %f GHz' %pumps
                try:
                    datan = ns.takeNoiseScan(sample, save = False)
                    datan[:,1] = datan[:,1] - calibn[:,1]
                    SNR = data[:,2]-datan[:,1]
                    SNR.shape = (len(SNR),1)
                    data = np.hstack((data,datan[:,1:], SNR))
                    if first:
                        dv = saveData3D(sample,data,datasetName)
                        first = False
                    else:
                        saveData3D(sample,data,datasetName,dataVault = dv)
                except:
                    time.sleep(1)
                    try:
                        datan = ns.takeNoiseScan(sample, save = False)
                        datan[:,1] = datan[:,1] - calibn[:,1]
                        SNR = data[:,2]-datan[:,1]
                        SNR.shape(len(SNR),1)
                        data = np.hstack((data,datan[:,1:],SNR))
                        if first:
                            dv = saveData3D(sample,data)
                            first = False
                        else:
                            saveData3D(sample,data,dataVault = dv)
                    except:
                        print 'Scan failed for power value of %f dBm' %pows
        an.output(False)
    except:
        print 'scan failed'
        an.output(False)
        
        
        
        
def saveData3D(sample, data, datasetName, dataVault = None):
    if dataVault == None:
        cxn = sample._cxn
        ampMeas = sample['PNA']
        SA = sample['noiseMeas']
        dv = cxn.data_vault
        dv.cd(sample._dir, True)
        nameString = datasetName
        independents = ['frequency [GHz]','Pump Power [dBm]']
        dependents = ['Gain (S12) [dB]', 'Noise Gain[dB]','SNR improvement [dB]']
        dv.new(nameString, independents, dependents)
        p = dv.packet()
        pnak = ampMeas.keys()
        sak = SA.keys()
        for key in pnak:
            p.add_parameter(key, ampMeas.__getitem__(key))
        for key in sak:
            if key in pnak:
                pass
            else:
                p.add_parameter(key, SA.__getitem__(key))
        p.send()
        dv.add(data)
        return dv
    else:
        dataVault.add(data)