import labrad
from labrad.units import Unit
from labrad.types import Value
V, GHz, MHz, Hz, dBm, dB, K, ns = [Unit(s) for s in ('V','GHz','MHz', 'Hz', 'dBm', 'dB', 'K', 'ns')]
import numpy as np
import time
import setbias as sb
import powerScan as ps
import pyle.dataking.util as util
import frequencyScan as fs
import powerScan as ps
import noiseScan as ns

def measureGainBandwidth(sample, pumpPowers, frequency, address):

    cxn = sample._cxn
    hittite = cxn.hittite_t2100_server
    hittite.select_device(address)
    hittite.output(False)
    hittite.output(True)
    hittite.output(False)
    PNA = sample['PNA']
    SA = sample['noiseMeas']
    

    hittite.frequency(2*frequency*1e9)
    SA['ParampPumpFreq'] = 2*frequency
    SA['ParampPumpPower'] = 'off'
    SA['freq'] = frequency*1000
    ns.takeNoiseScan(sample)
    
    PNA['startFreq'] = frequency-0.05
    PNA['stopFreq'] = frequency+0.05
    PNA['ParampPumpFreq'] = 2*frequency
    PNA['CWfrequency' ] = frequency+0.00075
    PNA['ParampPumpPower'] = 'off'
    fs.freqScan(sample)
    
    for pow in pumpPowers:
        hittite.output(True)
        hittite.amplitude(pow)
        time.sleep(5)
        
        SA['ParampPumpPower'] = pow
        ns.takeNoiseScan(sample)
       
        PNA['ParampPumpPower'] = pow
        fs.freqScan(sample)
        ps.powerScan(sample)
        print 'done with point'
        
    hittite.output(False)   
        

     
        
        
        
        
                