

import PyQt4.Qt as Qt
import PyQt4.QtCore as QtCore

class DummyBar(object):
    def showMessage(*args):
        pass
        

class ListArranger(Qt.QWidget):
    ''' A set of handlers for modifying a QListWidget. '''
    
    def __init__(self, parent, list, statusBar = DummyBar(), layout=Qt.QHBoxLayout):
        Qt.QWidget.__init__(self, parent)
        self.list = list
        self.statusBar = statusBar

        self.up = Qt.QPushButton("Up")
        self.up.clicked.connect(self.upFunc)
        self.down = Qt.QPushButton("Down")
        self.down.clicked.connect(self.downFunc)
        self.delete = Qt.QPushButton("Delete")
        self.delete.clicked.connect(self.deleteFunc)
        self.clear = Qt.QPushButton("Clear")
        self.clear.clicked.connect(self.clearFunc)
        hbox = layout()
        hbox.addWidget(self.up)
        hbox.addWidget(self.down)
        hbox.addWidget(self.delete)
        hbox.addWidget(self.clear)
        self.setLayout(hbox)
        
    
    def upFunc(self):
        i = self.list.currentRow()
        if i > 0:
            it = self.list.takeItem(i)
            self.list.insertItem(i-1, it)
            self.list.setCurrentRow(i-1)
        elif i == 0:
            self.statusBar.showMessage("Already at top.", 3000)
        else:
            self.statusBar.showMessage("No item selected to move up.", 3000)
            
    def downFunc(self):
        i = self.list.currentRow()
        if i < self.list.count() - 1:
            it = self.list.takeItem(i)
            self.list.insertItem(i+1, it)
            self.list.setCurrentRow(i+1)
        elif i == -1:
            self.statusBar.showMessage("No item selected to move down.", 3000)
        elif i >= self.list.count() - 1:
            self.statusBar.showMessage("Already at bottom.", 3000)
        else:
            self.statusBar.showMessage("Oops", 3000)
            
    def deleteFunc(self):
        i = self.list.currentRow()
        if i >= 0:
            self.list.takeItem(i)
        else:
            self.statusBar.showMessage("No item selected to delete.", 3000)
            
    def clearFunc(self):
        self.list.clear()
        self.statusBar.showMessage("List cleared.", 3000)
        
