import os
import numpy as np

import matplotlib
import matplotlib.pyplot as plt
plt.ion()
matplotlib.rcParams['axes.grid'] = True
matplotlib.rcParams['lines.marker'] = '.'
matplotlib.rcParams['lines.linestyle'] = None

import sys
sys.path.insert(1, 'U:\Daniel\DataTaking\LabRAD\dev\pyle')

import labrad
from labrad.units import Unit,Value

rad, ns, us, s, MHz, GHz, mV, V, dBm = (Unit(s) for s in ['rad','ns','us','s','MHz','GHz','mV','V','dBm'])


import pyle.util.registry_wrapper2 as registry
import pyle.envelopes as env
import pyle.dataking.envelopehelpers as eh
import pyle.util.sweeptools as st
import pyle.workflow as workflow
import pyle.plotting.dstools as ds

import pyle.dataking.DevDaniel.Qubit.readoutScans as ros
import pyle.dataking.DevDaniel.Qubit.readout as ro
import pyle.dataking.singleQubit as sq

def switchSession(session=None, user=None):
    """Switch the current session, using the global connection object"""
    global s
    if user is None:
        user = s._dir[1]
    s = workflow.switchSession(cxn, user, session)


def pipe_filling_factor(board_group=('DR Direct Ethernet', 1)):
    """Download performance data from the GHz DACs and calculate
    the fraction of time that the GHz DAC pipeline is full.
    """
    with labrad.connect() as cxn:
        perf = dict(cxn.ghz_dacs.performance_data())
    times = perf[board_group][3].asarray
    error_rate = sum(times == 0) / float(len(times))
    return 1 - error_rate


# connect to labrad and setup a wrapper for the current sample
cxn = labrad.connect()
switchSession(user='Daniel')

### MAGIC CHAT ###
# import socket
# try:
    # chatSock = socket.socket()
    # chatSock.connect(('localhost',12345))
# except:
    # chatSock.close()
    # print("Chat server does not exist")

# def magicChat(self, arg):
    # chatSock.send(arg)

# _ip.expose_magic('c', magicChat)