import os

import numpy as np
import matplotlib.pyplot as plt
import sys
sys.path.insert(0, 'U:\\Rami\\pyle\\dev\\pyle')
#sys.path.insert(0, 'U:\\Julian\\LABRAD\\dev\\pyle')

import labrad
from labrad.units import Unit,Value

rad, ns, us, MHz, GHz, mV, V, dBm = (Unit(s) for s in ['rad','ns','us','MHz','GHz','mV','V','dBm'])

#from pyle import registry
from pyle.util import registry_wrapper2 as registry
from pyle import envelopes as env
from pyle.dataking import envelopehelpers as eh
from pyle.dataking import fpgaseqTransmon as fseqt
#from pyle.dataking import multiqubit as mq
from pyle.dataking import multipleQubit as mq
from pyle.dataking import singleQubit as sq
#from pyle.dataking import transmonrami5 as tr
#from pyle.dataking import resonator as res
from pyle.util import sweeptools as st
from pyle.workflow import switchSession as pss
from pyle.plotting import dstools as ds
from pyle import gates
from pyle import gateCompiler as gc
from pyle.analysis import FluxNoiseAnalysis as fna
from pyle.datavault import DataVaultWrapper
from pyle.dataking import automateDaily as ad
from pyle.dataking.benchmarking import randomizedBenchmarking as rb
from pyle.dataking import toadd as sp
from pyle.dataking import util as util
 
def switchSession(session=None, user=None):
    """Switch the current session, using the global connection object"""
    global s
    if user is None:
        user = s._dir[1]
    s = pss(cxn, user, session)
    global dvw
    dvw = DataVaultWrapper(s)


def pipe_filling_factor(board_group=('DR Direct Ethernet', 1)):
    """Download performance data from the GHz DACs and calculate
    the fraction of time that the GHz DAC pipeline is full.
    """
    with labrad.connect() as cxn:
        perf = dict(cxn.ghz_dacs.performance_data())
    times = perf[board_group][3].asarray
    error_rate = sum(times == 0) / float(len(times))
    return 1 - error_rate


# connect to labrad and setup a wrapper for the current sample
cxn = labrad.connect()
switchSession(user='Rami')