''' gate_mixtures.py

this was the code for comparing different gate mixtures.

this was pulled out of dephasing_funcs_np.py so many of the function calls
probably need "dfn." in front of them
'''
import dephasing_funcs_np as dfn

def make_gate_group(n_pi2, n_pi, n_pi2_z, n_pi_z, n_I):
    group = []
    group_inv = []
    for i in range(n_pi2):
        c = nps.pi2gates[:-1] + nps.pi2gates_inv[:-1]
        x = random.randint(0, 3)
        group.append(c[x])
        group_inv.append(c[(x+2)%4])
    for i in range(n_pi):
        c = nps.pigates[:-1] + nps.pigates_inv[:-1]
        x = random.randint(0,3)
        group.append(c[x])
        group_inv.append(c[(x+2)%4])
    for i in range(n_pi2_z):
        c = [nps.pi2gates[-1], nps.pi2gates_inv[-1]]
        x = random.randint(0,1)
        group.append(c[x])
        group_inv.append(c[int(not x)])
    for i in range(n_pi_z):
        c = [nps.pigates[-1], nps.pigates_inv[-1]]
        x = random.randint(0,1)
        group.append(c[x])
        group_inv.append(c[int(not x)])
    for i in range(n_I):
        group.append(nps.I)
        group_inv.append(nps.I)
        
    return group, group_inv
    
def compare_gate_mixtures(n_pi2=12, n_pi=range(25), n_pi2_z=range(25), 
                        n_pi_z=range(25), n_I=range(25), num_avg=800):
    slopes = []
    n_gates = []
    labels = []
    total = 0
    
    if n_pi:
        gates = []
        gates_inv = []
        for i in n_pi:
            #g, gi = make_gate_group(n_pi2, i, 0, 0, 0)
            #gates.append(g)
            #gates_inv.append(gi)
            gates.append([n_pi2, i, 0, 0, 0])
            gates_inv.append(None)
        _, _, uncorr, corr = slope_vs_gate_groups(gates, gates_inv, plot=False, num_avg=num_avg)
        slopes.append((uncorr, corr))
        n_gates.append(n_pi)
        labels.append(r"$X/Y (\pi)$ gates")
        total += 1
    
    if n_pi2_z:
        gates = []
        gates_inv = []
        for i in n_pi2_z:
            #g, gi = make_gate_group(n_pi2, 0, i, 0, 0)
            #gates.append(g)
            #gates_inv.append(gi)
            gates.append([n_pi2, 0, i, 0, 0])
            gates_inv.append(None)
        _, _, uncorr, corr = slope_vs_gate_groups(gates, gates_inv, plot=False, num_avg=num_avg)
        slopes.append((uncorr, corr))
        n_gates.append(n_pi2_z)
        labels.append(r"$Z(\pi/2)$ gates")
        total += 1
    
    if n_pi_z:
        gates = []
        gates_inv = []
        for i in n_pi_z:
            #g, gi = make_gate_group(n_pi2, 0, i, 0, 0)
            #gates.append(g)
            #gates_inv.append(gi)
            gates.append([n_pi2, 0, 0, i, 0])
            gates_inv.append(None)
        _, _, uncorr, corr = slope_vs_gate_groups(gates, gates_inv, plot=False, num_avg=num_avg)
        slopes.append((uncorr, corr))
        n_gates.append(n_pi_z)
        labels.append(r"$Z(\pi)$ gates")
        total += 1
    
    if n_I:
        gates = []
        gates_inv = []
        for i in n_I:
            #g, gi = make_gate_group(n_pi2, 0, 0, 0, i)
            #gates.append(g)
            #gates_inv.append(gi)
            gates.append([n_pi2, 0, 0, 0, i])
            gates_inv.append(None)
        _, _, uncorr, corr = slope_vs_gate_groups(gates, gates_inv, plot=False, num_avg=num_avg)
        slopes.append((uncorr, corr))
        n_gates.append(n_I)
        labels.append(r"$I$ gates")    
        total += 1
    
    import matplotlib.pyplot as plt
    ax = plt.figure().add_subplot(111)
    colors = ['r', 'b', 'g', 'm']
    for i in range(total):
        ax.plot(n_gates[i], slopes[i][0], '%ss' % colors[i], label=labels[i]+' uncorrelated')
        ax.plot(n_gates[i], slopes[i][1], '%so' % colors[i], label=labels[i]+' correlated')
    ax.legend(numpoints=1, loc='best')
    ax.set_ylabel("Slope", fontsize=19)
    ax.set_xlabel("Number of introduced gates", fontsize=19)
    plt.show()
    
def slope_vs_gate_groups(gate_group_list, gate_group_list_inv, phi_g=1e-4,
                            num_avg=400, Nlist=range(5, 100, 5), plot=True):
    import rb_dephasing as rbd
    data_uncorr = [np.zeros_like(Nlist, dtype=np.float64)] * len(gate_group_list)
    data_corr = [np.zeros_like(Nlist, dtype=np.float64)] * len(gate_group_list)
    slopes_corr, slopes_uncorr = [], []
    for i in range(len(gate_group_list)):
        OLD = '''for k in range(num_avg):
            for j, n in enumerate(Nlist):
                data_uncorr[i][j] += generic(gate_group_list[i],
                                            gate_group_list_inv[i],
                                            phi_g=phi_g,
                                            N=n,
                                            correlated=False)
                data_corr[i][j] += generic(gate_group_list[i],
                                            gate_group_list_inv[i],
                                            phi_g=phi_g,
                                            N=n,
                                            correlated=True)
        data_uncorr[i] /= num_avg
        data_corr[i] /= num_avg
        '''
        data_uncorr[i] = multiprocess_generic(gate_group_list[i],
                                                gate_group_list_inv[i],
                                                phi_g=phi_g,
                                                correlated=False,
                                                num_avg=num_avg,
                                                Nlist=Nlist)
        data_corr[i] = multiprocess_generic(gate_group_list[i],
                                                gate_group_list_inv[i],
                                                phi_g=phi_g,
                                                correlated=True,
                                                num_avg=num_avg,
                                                Nlist=Nlist)
        slopes_uncorr.append(rbd.fit_slope(np.array(Nlist), data_uncorr[i], dphi=phi_g, guess=1.0/6.0))
        slopes_corr.append(rbd.fit_slope(np.array(Nlist), data_corr[i], dphi=phi_g, guess=1.0/6.0))
    if plot:
        import matplotlib.pyplot as plt
        ax = plt.figure().add_subplot(111)
        ax.plot(slopes_uncorr, 'bo', label="Uncorrelated")
        ax.plot(slopes_corr, 'ro', label="Correlated")
        ax.set_xlabel('Gate Group Index', fontsize=19)
        ax.set_ylabel('Slope', fontsize=19)
        ax.legend(numpoints=1)
    return data_uncorr, data_corr, slopes_uncorr, slopes_corr
